<?php
/**
 * Zeigt alle Einträge von der Tabelle whitelist der Datenbank an
 * 
 */
class Dos {

	/**
	 *
	 * @var beroConf Instance root db
	 */
	private $bc;

	function __construct() {
		require_once('/usr/fallback/beroConf.php');
		$this->bc = new beroConf('root');
	}

	function allowLan() {
		$excludelan = $this->bc->get("root", "excludelan");
		($excludelan == 1) ? $checked = "" : $checked = "checked";
		return $checked;
	}

	private function _save() {
		$this->bc->set("root", "excludelan", $_POST['allowlan']);
		return Helper::activate(1, true, $_GET['m'], ACTIVATE);
	}

	/**
	 * Die einträge der whitelist Tabelle werden formatiert angezeigt
	 * 
	 * @return string HTML Inhalt
	 */

	function display() {

		include "./includes/functions.php";
		//Das Objekt funktions wird erzeugt um später die Navigationsleiste zu erzeugen.
		$functions = new functions();

		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		$start = $_GET['start'];
		$order = $_GET['order'];
		$sort = $_GET['sort'];


		
		$ba = new beroAri();

		$span = 15;
		$query = $ba->select('SELECT * FROM whitelist');
		$record_count = sqlite_num_rows($query);
		$test = $record_count / $span;
		$test = (int) $test;
		if ($record_count == 0) {
			$next_add = 0;
		} else {
			$next_add = ($test * $span);
		}

		$start = $start == '' ? 0 : $start;
		$order = $order;
		$sort = $sort;
		$name = "DOS_TITLE_DIS";
		include('./includes/header.php');

		$whitelist_table = $this->dynamic_table_whitelist();
		ob_start();
		?>
		<h1 class='text-center'> Whitelist </h1>
		<script>
			function del(table, option) {
				conf = confirm('<? echo DOS_DELETE_MESS1_DIS ?>? ');
				if (conf == false) {
					return false;
				} else {
					window.location = './misc/delete.php?m=<? echo $_GET['m'] ?>&id=' + option + '&table=' + table;
				}
			}
			function delblacklist(table, option) {
				conf = confirm('<? echo DOS_DELETE_MESS1_DIS ?>? ');
				if (conf == false) {
					return false;
				} else {
					window.location = './misc/delete.php?m=<? echo $_GET['m'] ?>&id=' + option + '&table=' + table;
				}
			}
		</script>
		<div class='modal fade bs-example-modal-lg' id='dos-popup' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
			<div class='modal-dialog modal-lg'>
				<div class='modal-content'>
					<div class='modal-header'>
						<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
						<h4 class='modal-title' id='myModalLabel'><? echo DOS_TITLE_DIS ?></h4>
					</div>
					<div class='modal-body'>
					</div>
				</div>
			</div>
		</div>
		<br>
		<div id='container'>
			<? echo $whitelist_table ?>
		</div>
		<br>
		<div class='text-center'>
			<a href='modules/Dos/dos_popup.php?start=<? echo $next_add ?>' role='button' data-remote='false' data-toggle='modal' data-target='#dos-popup' class='btn btn-default'>
				<? echo BUTTON_ADD ?>
			</a>
		</div>
		<script type="text/javascript">
			$('#dos-popup').on('show.bs.modal', function (e) {
				var link = $(e.relatedTarget);
				$('.modal-body').load(link.attr('href'));
			});
		</script>
		<?php
		$ba = new beroAri();

		//Erzeugung der Navigationsleiste.
		$query = $ba->select('SELECT * FROM whitelist');
		$record_count = sqlite_num_rows($query);
		$url_opts = array();
		$url_opts['sort'] = $sort;
		$url_opts['order'] = $order;
		?>
		<div class='text-center'>
			<? echo $functions->displayNavigationBlock($m, $q, $url_opts, $start, $span, $record_count) ?>
		</div>

		<br>
		<br>
		<form action='' class='allow form-horizontal' method='POST'>
			<input type=hidden name=m value='<? echo $m ?>'>

			
			<table class='table table-striped table-bordered' style='max-width:350px; margin:auto;'>
				<div class="text-center">
					<button type='submit' class='btn btn-default' onclick='selectall();'><? echo BUTTON_SAVE ?></button>
				</div>
				</td>
				</tr>
			</table>
			<br>
		</form>


		<h1 class='text-center'> Blacklist </h1>
<?php
		$blacklist_table = $this->dynamic_table_blacklist();
?>
		<div class='modal fade bs-example-modal-lg' id='dos-popup' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
			<div class='modal-dialog modal-lg'>
				<div class='modal-content'>
					<div class='modal-header'>
						<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
						<h4 class='modal-title' id='myModalLabel'><? echo DOS_TITLE_DIS ?></h4>
					</div>
					<div class='modal-body'>
					</div>
				</div>
			</div>
		</div>
		<br>
		<div id='container'>
			<? echo $blacklist_table ?>
		</div>
		<br>

		<script type="text/javascript">
			$('#dos-popup').on('show.bs.modal', function (e) {
				var link = $(e.relatedTarget);
				$('.modal-body').load(link.attr('href'));
			});
		</script>
		


		<?php
		$ret .= ob_get_clean();

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}

	/**
	 * Liefert den HTML Code für die Tabelle
	 * 
	 * @return string HTLM code für die Tabelle
	 */

	function dynamic_table_whitelist() {
		//ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		require_once("./includes/lang.php");
		$start = $_GET['start'];

		//Das Header der Tabelle sind die Spaltennamen von whitelist
		$columns = $ba->column_type('whitelist');
		$i = 0;
		$columnsToShow = array("address");
		$colName = array("address" => DOS_ADDRESS_DIS);
		foreach ($columns as $column => $type) {
			if (in_array($column, $columnsToShow))
				$cols .= "<th>" . $colName[$column] . "</th>";
		}

		/* Die Einträge werden von der Tabelle whitelist gelesen, formatiert und in einer
		  Tabelle geschrieben, zusätzlich werden 2 Knöpfe eingebaut: modify und delete */
		$page = (($start / 15) + 1);
		if (!$start)
			$start = 0;
		$id = 0;

		for ($j = 1; $j <= $page; $j++) {
			$query = $ba->select('SELECT * FROM whitelist ORDER BY id asc limit 15 offset ' . $start);
			$rows = '';
			while ($entry = $ba->fetch_array($query)) {
				$rows .= "<tr>";
				for ($i = 0; $i < (count($columnsToShow)); $i++) {
					$col_name = $columnsToShow[$i];
					$rows .= "<td>" . $entry[$col_name] . "</td>";
				}
				$id = $entry['id'];
				$rows .= "<td class='buttons'>
				<a href='modules/Dos/dos_popup.php?id=" . $id . "' data-remote='false' data-toggle='modal' data-target='#dos-popup' class='popup_download'>
					<img src='./includes/images/modify.png'>
				</a>&nbsp;
				<a class='popup_download' onclick=\"del('whitelist','" . $id . "');\">
            	    <img src='./includes/images/delete.png'>
				</a>
				</td></tr>";
			}
		}

		$table = "<table class='table table-striped table-bordered' id='table' style='max-width:600px; margin:auto;'>"
			. "<tr>" 
			. $cols 
			. "<th></th>"
			. "</tr>"
			. $rows 
			. "</table>";
		//Rückgabe: Erzeugte Tabelle mit den Einträgen der Tabelle whitelist der Datenbank
		return $table;
	}

	function dynamic_table_blacklist() {
		
		require_once("./includes/lang.php");
		require_once "./includes/isgwtelnet.php";
		$i = 0;
		
		$cols .= "<th>" . DOS_BLACKLIST_ID . "</th>";
		$cols .= "<th>" . DOS_BLACKLIST_TIME . "</th>";
		$cols .= "<th>" . DOS_BLACKLIST_IP . "</th>";
		
		$isgw = new isgwtelnet();
		$result = $isgw->isgw_login();
		$blacklistresult = $isgw->isgw_blacklist();
	
		$bl_rows = explode("\n", $blacklistresult);
		$i=0;

		foreach ($bl_rows as $value){
			$id = -1;
			if (strncmp ("id:", $value, 3) != 0) {
				continue;
			}
			
			$rows .= "<tr>";
			$rvals = explode(" ", $value);
			
			if (count($rvals) != 3) {
				continue;
			}
			
			
			foreach ($rvals as $rval){

				$xval = explode(":", $rval);
				$rows .= "<td>" . $xval[1] . "</td>";
				if ($id == -1) {
					$id = $xval[1];
				}
			}
			
			$rows .= "<td class='buttons'>

			<a class='popup_download' onclick=\"delblacklist('blacklist','" . $id . "');\">
			<img src='./includes/images/delete.png'>
			</a>
			</td></tr>";
			
		}

		$table = "<table class='table table-striped table-bordered' id='table' style='max-width:600px; margin:auto;'>"
			. "<tr>" 
			. $cols 
			. "<th></th>"
			. "</tr>"
			. $rows 
			. "</table>";
		//Rückgabe: Erzeugte Tabelle mit den Einträgen der Tabelle whitelist der Datenbank
		return $table;
	}
	
}
?>
